import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

import java.util.List;

import javafx.application.Application;
import javafx.application.Platform;

import javafx.beans.value.ChangeListener;
import javafx.beans.value.ObservableValue;

import javafx.event.ActionEvent;
import javafx.event.Event;
import javafx.event.EventHandler;

import javafx.scene.Scene;

import javafx.scene.control.CheckMenuItem;
import javafx.scene.control.IndexRange;
import javafx.scene.control.Label;
import javafx.scene.control.Menu;
import javafx.scene.control.MenuBar;
import javafx.scene.control.MenuItem;
import javafx.scene.control.SeparatorMenuItem;
import javafx.scene.control.TextArea;

import javafx.scene.input.Clipboard;
import javafx.scene.input.Dragboard;
import javafx.scene.input.DragEvent;
import javafx.scene.input.KeyCharacterCombination;
import javafx.scene.input.KeyCombination;
import javafx.scene.input.TransferMode;

import javafx.scene.layout.BorderPane;

import javafx.scene.paint.Color;

import javafx.stage.FileChooser;
import javafx.stage.Stage;
import javafx.stage.WindowEvent;

public class JPadFX extends Application
{
   private final static String DEFAULT_TITLE = "Untitled - JPadFX";
   private final static String DEFAULT_STATUS = "JPadFX 1.0";
   private final static String SAVE_CHNGS = "Save changes?";
   private Stage stage;
   private Clipboard cb;
   private FileChooser fc;
   private boolean fDirty;
   private TextArea ta;
   private Label lbl;
   private File fileCurrent;

   @Override
   public void start(final Stage primaryStage)
   {
      stage = primaryStage;
      cb = Clipboard.getSystemClipboard();
      fc = new FileChooser();
      fc.setInitialDirectory(new File("."));
      FileChooser.ExtensionFilter ef1;
      ef1 = new FileChooser.ExtensionFilter("TXT documents (*.txt)", "*.txt");
      FileChooser.ExtensionFilter ef2;
      ef2 = new FileChooser.ExtensionFilter("All Files", "*.*");
      fc.getExtensionFilters().addAll(ef1, ef2);
      BorderPane root = new BorderPane();
      MenuBar mb = new MenuBar();
      Menu mFile = new Menu("File");
      MenuItem miNew = new MenuItem("New");
      KeyCharacterCombination kccNew;
      kccNew = new KeyCharacterCombination("N", KeyCombination.CONTROL_DOWN);
      miNew.setAccelerator(kccNew);
      EventHandler<ActionEvent> ehae;
      ehae = new EventHandler<ActionEvent>()
      {
         @Override
         public void handle(ActionEvent ae)
         {
            if (fDirty)
            {
               AreYouSure ays = new AreYouSure(stage, SAVE_CHNGS);
               EventHandler<ActionEvent> ehae1;
               ehae1 = new EventHandler<ActionEvent>()
               {
                  @Override
                  public void handle(ActionEvent ae)
                  {
                     if (doSave())
                        doNew();
                  }
               };
               ays.setOnYes(ehae1);
               EventHandler<ActionEvent> ehae2;
               ehae2 = new EventHandler<ActionEvent>()
               {
                  @Override
                  public void handle(ActionEvent ae)
                  {
                     doNew();
                  }
               };
               ays.setOnNo(ehae2);
               ays.show();
            }
            else
               doNew();
         }
      };
      miNew.setOnAction(ehae);
      mFile.getItems().add(miNew);
      MenuItem miOpen = new MenuItem("Open...");
      KeyCharacterCombination kccOpen;
      kccOpen = new KeyCharacterCombination("O", KeyCombination.CONTROL_DOWN);
      miOpen.setAccelerator(kccOpen);
      ehae = new EventHandler<ActionEvent>()
      {
         @Override
         public void handle(ActionEvent ae)
         {
            if (fDirty)
            {
               AreYouSure ays = new AreYouSure(stage, SAVE_CHNGS);
               EventHandler<ActionEvent> ehae1;
               ehae1 = new EventHandler<ActionEvent>()
               {
                  @Override
                  public void handle(ActionEvent ae)
                  {
                     if (doSave())
                        doOpen();
                  }
               };
               ays.setOnYes(ehae1);
               EventHandler<ActionEvent> ehae2;
               ehae2 = new EventHandler<ActionEvent>()
               {
                  @Override
                  public void handle(ActionEvent ae)
                  {
                     doOpen();
                  }
               };
               ays.setOnNo(ehae2);
               ays.show();
            }
            else
               doOpen();
         }
      };
      miOpen.setOnAction(ehae);
      mFile.getItems().add(miOpen);
      MenuItem miSave = new MenuItem("Save");
      KeyCharacterCombination kccSave;
      kccSave = new KeyCharacterCombination("S", KeyCombination.CONTROL_DOWN);
      miSave.setAccelerator(kccSave);
      ehae = new EventHandler<ActionEvent>()
      {
         @Override
         public void handle(ActionEvent ae)
         {
            doSave();
         }
      };
      miSave.setOnAction(ehae);
      mFile.getItems().add(miSave);
      MenuItem miSaveAs = new MenuItem("Save As...");
      ehae = new EventHandler<ActionEvent>()
      {
         @Override
         public void handle(ActionEvent ae)
         {
            doSaveAs();
         }
      };
      miSaveAs.setOnAction(ehae);
      mFile.getItems().add(miSaveAs);
      if (getHostServices().getWebContext() == null)
      {
         mFile.getItems().add(new SeparatorMenuItem());
         MenuItem miExit = new MenuItem("Exit");
         ehae = new EventHandler<ActionEvent>()
         {
            @Override
            public void handle(ActionEvent ae)
            {
               doExit(ae);
            }
         };
         miExit.setOnAction(ehae);
         mFile.getItems().add(miExit);
      }
      EventHandler<Event> ehe;
      ehe = new EventHandler<Event>()
      {
         @Override
         public void handle(Event e)
         {
            if (getHostServices().getWebContext() == null)
               lbl.setText("New doc|Open existing doc|Save changes|Exit");
            else
               lbl.setText("New doc|Open existing doc|Save changes");
         }
      };
      mFile.setOnShowing(ehe);
      ehe = new EventHandler<Event>()
      {
         @Override
         public void handle(Event e)
         {
            lbl.setText(DEFAULT_STATUS);
         }
      };
      mFile.setOnHiding(ehe);
      mb.getMenus().add(mFile);
      Menu mEdit = new Menu("Edit");
      final MenuItem miCut = new MenuItem("Cut");
      KeyCharacterCombination kccCut;
      kccCut = new KeyCharacterCombination("X", KeyCombination.CONTROL_DOWN);
      miCut.setAccelerator(kccCut);
      miCut.setDisable(true);
      ehae = new EventHandler<ActionEvent>()
      {
         @Override
         public void handle(ActionEvent ae)
         {
            ta.cut();
         }
      };
      miCut.setOnAction(ehae);
      mEdit.getItems().add(miCut);
      final MenuItem miCopy = new MenuItem("Copy");
      KeyCharacterCombination kccCopy;
      kccCopy = new KeyCharacterCombination("C", KeyCombination.CONTROL_DOWN);
      miCopy.setAccelerator(kccCopy);
      miCopy.setDisable(true);
      ehae = new EventHandler<ActionEvent>()
      {
         @Override
         public void handle(ActionEvent ae)
         {
            ta.copy();
         }
      };
      miCopy.setOnAction(ehae);
      mEdit.getItems().add(miCopy);
      final MenuItem miPaste = new MenuItem("Paste");
      KeyCharacterCombination kccPaste;
      kccPaste = new KeyCharacterCombination("V", KeyCombination.CONTROL_DOWN);
      miPaste.setAccelerator(kccPaste);
      ehae = new EventHandler<ActionEvent>()
      {
         @Override
         public void handle(ActionEvent ae)
         {
            ta.paste();
         }
      };
      miPaste.setOnAction(ehae);
      mEdit.getItems().add(miPaste);
      mEdit.getItems().add(new SeparatorMenuItem());
      MenuItem miSelectAll = new MenuItem("Select All");
      KeyCharacterCombination kccSA;
      kccSA = new KeyCharacterCombination("A", KeyCombination.CONTROL_DOWN);
      miSelectAll.setAccelerator(kccSA);
      ehae = new EventHandler<ActionEvent>()
      {
         @Override
         public void handle(ActionEvent ae)
         {
            ta.selectAll();
         }
      };
      miSelectAll.setOnAction(ehae);
      mEdit.getItems().add(miSelectAll);
      ehe = new EventHandler<Event>()
      {
         @Override
         public void handle(Event e)
         {
            miPaste.setDisable(!cb.hasString());
            lbl.setText("Cut or copy selected text|Paste|Select all text");
         }
      };
      mEdit.setOnShowing(ehe);
      ehe = new EventHandler<Event>()
      {
         @Override
         public void handle(Event e)
         {
            lbl.setText(DEFAULT_STATUS);
         }
      };
      mEdit.setOnHiding(ehe);
      mb.getMenus().add(mEdit);
      Menu mFormat = new Menu("Format");
      final CheckMenuItem cmiWordWrap = new CheckMenuItem("Word Wrap");
      ehae = new EventHandler<ActionEvent>()
      {
         @Override
         public void handle(ActionEvent ae)
         {
            ta.setWrapText(cmiWordWrap.isSelected());
         }
      };
      cmiWordWrap.setOnAction(ehae);
      mFormat.getItems().add(cmiWordWrap);
      ehe = new EventHandler<Event>()
      {
         @Override
         public void handle(Event e)
         {
            lbl.setText("Enable/disable word wrap");
         }
      };
      mFormat.setOnShowing(ehe);
      ehe = new EventHandler<Event>()
      {
         @Override
         public void handle(Event e)
         {
            lbl.setText(DEFAULT_STATUS);
         }
      };
      mFormat.setOnHiding(ehe);
      mb.getMenus().add(mFormat);
      Menu mHelp = new Menu("Help");
      final MenuItem miAbout = new MenuItem("About JPadFX");
      ehae = new EventHandler<ActionEvent>()
      {
         @Override
         public void handle(ActionEvent ae)
         {
            new About(stage).show();
         }
      };
      miAbout.setOnAction(ehae);
      mHelp.getItems().add(miAbout);
      ehe = new EventHandler<Event>()
      {
         @Override
         public void handle(Event e)
         {
            lbl.setText("View about information");
         }
      };
      mHelp.setOnShowing(ehe);
      ehe = new EventHandler<Event>()
      {
         @Override
         public void handle(Event e)
         {
            lbl.setText(DEFAULT_STATUS);
         }
      };
      mHelp.setOnHiding(ehe);
      mb.getMenus().add(mHelp);
      root.setTop(mb);
      root.setCenter(ta = new TextArea());
      ChangeListener<Number> cln;
      cln = new ChangeListener<Number>()
      {
         @Override
         public void changed(ObservableValue ov, Number oldval, Number newval)
         {
            fDirty = true;
         }
      };
      ta.lengthProperty().addListener(cln);
      ChangeListener<String> cls;
      cls = new ChangeListener<String>()
      {
         @Override
         public void changed(ObservableValue ov,
                             String oldval,
                             String newval)
         {
            if (ta.getSelectedText().length() != 0)
            {
               miCopy.setDisable(false);
               miCut.setDisable(false);
            }
            else
            {
               miCopy.setDisable(true);
               miCut.setDisable(true);
            }
         }
      };
      ta.selectedTextProperty().addListener(cls);
      EventHandler<DragEvent> ehde;
      ehde = new EventHandler<DragEvent>()
      {
         @Override
         public void handle(DragEvent de)
         {
            if (de.getDragboard().hasFiles())
               de.acceptTransferModes(TransferMode.COPY);
            de.consume();
         }
      };
      ta.setOnDragOver(ehde);
      ehde = new EventHandler<DragEvent>()
      {
         @Override
         public void handle(DragEvent de)
         {
            final Dragboard db = de.getDragboard();
            boolean success = false;
            if (db.hasFiles())
            {
               if (fDirty)
               {
                  AreYouSure ays = new AreYouSure(stage, SAVE_CHNGS);
                  EventHandler<ActionEvent> ehae1;
                  ehae1 = new EventHandler<ActionEvent>()
                  {
                     @Override
                     public void handle(ActionEvent ae)
                     {
                        if (doSave())
                           doOpen(db.getFiles().get(0));
                     }
                  };
                  ays.setOnYes(ehae1);
                  EventHandler<ActionEvent> ehae2;
                  ehae2 = new EventHandler<ActionEvent>()
                  {
                     @Override
                     public void handle(ActionEvent ae)
                     {
                        doOpen(db.getFiles().get(0));
                     }
                  };
                  ays.setOnNo(ehae2);
                  ays.show();
               }
               else
                  doOpen(db.getFiles().get(0));
               success = true;
            }
            de.setDropCompleted(success);
            de.consume();
         }
      };
      ta.setOnDragDropped(ehde);
      root.setBottom(lbl = new Label("JPadFX 1.0"));
      Scene scene = new Scene(root, 400, 400, Color.WHITE);
      primaryStage.setScene(scene);
      primaryStage.setTitle(DEFAULT_TITLE);
      EventHandler<WindowEvent> ehwe;
      ehwe = new EventHandler<WindowEvent>()
      {
         @Override
         public void handle(WindowEvent we)
         {
            doExit(we);
         }
      };
      primaryStage.setOnCloseRequest(ehwe);
      primaryStage.show();
      Application.Parameters params = getParameters();
      List<String> uparams = params.getUnnamed();
      if (uparams.size() != 0)
         doOpen(new File(uparams.get(0)));
   }
   private void doExit(Event e)
   {
      if (fDirty)
      {
         AreYouSure ays = new AreYouSure(stage, SAVE_CHNGS);
         EventHandler<ActionEvent> ehae1;
         ehae1 = new EventHandler<ActionEvent>()
         {
            @Override
            public void handle(ActionEvent ae)
            {
               if (doSave())
                  stage.close();
            }
         };
         ays.setOnYes(ehae1);
         EventHandler<ActionEvent> ehae2;
         ehae2 = new EventHandler<ActionEvent>()
         {
            @Override
            public void handle(ActionEvent ae)
            {
               stage.close();
            }
         };
         ays.setOnNo(ehae2);
         ays.show();
      }
      else
         stage.close();
      e.consume();
   }
   private void doNew()
   {
      fileCurrent = null;
      ta.setText("");
      stage.setTitle(DEFAULT_TITLE);
      fDirty = false;
   }
   private void doOpen()
   {
      doOpen(null);
   }
   private void doOpen(File file)
   {
      try
      {
         if (file == null)
            file = fc.showOpenDialog(stage);
         if (file == null)
            return;
         fc.setInitialDirectory(file.getParentFile());
         if (file.toString().indexOf(".") == -1)
            file = new File(file+".txt");
         ta.setText(read(file));
         // The following two lines ensure that scrollbars are displayed when
         // necessary.
         ta.end();
         ta.home();
         fileCurrent = file;
         ta.home();
         ta.requestFocus();
         stage.setTitle(file.toString()+" - JPadFX");
         fDirty = false;
      }
      catch (IOException ioe)
      {
         new Alert(stage, "I/O error: "+ioe.getMessage()).show();
      }
   }
   private boolean doSave()
   {
      if (fileCurrent == null)
         return doSaveAs();
      try
      {
         write(fileCurrent, ta.getText());
         fDirty = false;
         return true;
      }
      catch (IOException ioe)
      {
         new Alert(stage, "I/O error: "+ioe.getMessage()).show();
         return false;
      }
   }
   private boolean doSaveAs()
   {
      try
      {
         File file = fc.showSaveDialog(stage);
         if (file == null)
            return false;
         fc.setInitialDirectory(file.getParentFile());
         if (file.getName().indexOf(".") == -1)
            file = new File(file+".txt");
         write(file, ta.getText());
         fileCurrent = file;
         stage.setTitle(file.toString()+" - JPadFX");
         fDirty = false;
         return true;
      }
      catch (IOException ioe)
      {
         new Alert(stage, "I/O error: "+ioe.getMessage()).show();
         return false;
      }
   }
   private String read(File f) throws IOException
   {
      try (FileReader fr = new FileReader(f))
      {
         char[] buf = new char[(int) f.length()];
         fr.read(buf);
         return new String(buf);
      }
   }
   private void write(File f, String text) throws IOException
   {
      try (FileWriter fw = new FileWriter(f);
           PrintWriter pw = new PrintWriter(fw))
      {
         pw.print(text);
      }
   }
   public static void main(String[] args)
   {
      launch(args);
   }
}
